{{ define "main" }}
  {{ $vulnerabilities := .Site.Data.vulnerabilities }}
  {{ $total := 0 }}
  {{ $aging_vulns := dict }}
  {{ range $vulnerabilities.aging }}
    {{ $total = add $total .all_time }}
    {{ $aging_vulns = merge $aging_vulns (dict .severity (.all_time | default 0)) }}
  {{ end }}

  {{ if eq $total 0 }}
    <p>No Vulnerabilities</p>
  {{ else }}
    <h2>Open by severity</h2>

    {{ partial "vulnerabilities/metrics.html" $aging_vulns }}


    <h2>Breakdown</h2>

    <div class="table-responsive">
      <table class="table table-striped table-hover">
        <thead>
          <tr class="text-end">
            <th scope="col" class="text-start">#</th>
            <th scope="col" class="text-start">Project</th>
            <th scope="col">N (Critical/High/Unknown)</th>
            <th scope="col">N (Medium/Info/Low)</th>
            <th scope="col">Total</th>
          </tr>
        </thead>
        <tbody id="listTable">
          {{ $counter := 0 }}
          {{ $total := 0 }}
          {{ range $vulnerabilities.breakdown }}
            {{ $counter = add $counter 1 }}
            {{ $total = add $total .total }}
            <tr class="text-end">
              <th scope="row" class="text-start">{{ $counter }}</th>
              <td class="text-start">
                <a href="{{ printf "projects/%s" .path_with_namespace | urlize | relURL }}"
                  >{{ .path_with_namespace }}</a
                >
              </td>
              <td>{{ .critical_high_unknown | lang.FormatNumber 0 }}</td>
              <td>{{ .others | lang.FormatNumber 0 }}</td>
              <td>{{ .total | lang.FormatNumber 0 }}</td>
            </tr>
          {{ end }}
        </tbody>
        <tfoot>
          <tr>
            <td colspan="4"></td>
            <td class="text-end"><strong>{{ $total | lang.FormatNumber 0 }}</strong></td>
          </tr>

          <tr></tr>
        </tfoot>
      </table>
    </div>

    <h2>Triaged - Last 30 days</h2>

    <div class="table-responsive">
      <table class="table table-striped table-hover">
        <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Project</th>
            <th scope="col" class="text-end">Dismissed</th>
            <th scope="col" class="text-end">Confirmed</th>
            <th scope="col" class="text-end">Resolved</th>
            <th scope="col" class="text-end">Total</th>
          </tr>
        </thead>
        <tbody id="listTable">
          {{ $counter := 0 }}
          {{ $total_triaged := 0 }}
          {{ range $vulnerabilities.triage_ratios }}
            {{ $counter = add $counter 1 }}
            {{ $total := 0 }}
            {{ $total = add $total .total_dismissed }}
            {{ $total = add $total .total_confirmed }}
            {{ $total = add $total .total_resolved }}
            {{ $total_triaged = add $total_triaged $total }}
            <tr>
              <th scope="row">{{ $counter }}</th>
              <td>
                <a href="{{ printf "projects/%s" .path_with_namespace | urlize | relURL }}"
                  >{{ .path_with_namespace }}</a
                >
              </td>
              <td class="text-end">
                {{ .total_dismissed | lang.FormatNumber 0 }}
                <i
                  class="fas fa-info-circle"
                  data-bs-toggle="tooltip"
                  data-bs-placement="top"
                  title="Critical: {{ .dismissed_critical| lang.FormatNumber 0 }} - High: {{ .dismissed_high | lang.FormatNumber 0 }} - Unknown: {{ .dismissed_unknown | lang.FormatNumber 0 }} - Medium: {{ .dismissed_medium | lang.FormatNumber 0 }} - Low: {{ .dismissed_low | lang.FormatNumber 0 }} - Info: {{ .dismissed_info | lang.FormatNumber 0 }}"></i>
              </td>
              <td class="text-end">
                {{ .total_confirmed | lang.FormatNumber 0 }}
                <i
                  class="fas fa-info-circle"
                  data-bs-toggle="tooltip"
                  data-bs-placement="top"
                  title="Critical: {{ .confirmed_critical | lang.FormatNumber 0 }} - High: {{ .confirmed_high | lang.FormatNumber 0 }} - Unknown: {{ .confirmed_unknown | lang.FormatNumber 0 }} - Medium: {{ .confirmed_medium | lang.FormatNumber 0 }} - Low: {{ .confirmed_low | lang.FormatNumber 0 }} - Info: {{ .confirmed_info | lang.FormatNumber 0 }}"></i>
              </td>
              <td class="text-end">
                {{ .total_resolved | lang.FormatNumber 0 }}
                <i
                  class="fas fa-info-circle"
                  data-bs-toggle="tooltip"
                  data-bs-placement="top"
                  title="Critical: {{ .resolved_critical | lang.FormatNumber 0 }} - High: {{ .resolved_high | lang.FormatNumber 0 }} - Unknown: {{ .resolved_unknown | lang.FormatNumber 0 }} - Medium: {{ .resolved_medium | lang.FormatNumber 0 }} - Low: {{ .resolved_low | lang.FormatNumber 0 }} - Info: {{ .resolved_info | lang.FormatNumber 0 }}"></i>
              </td>
              <td class="text-end">{{ $total | lang.FormatNumber 0 }}</td>
            </tr>
          {{ end }}
        </tbody>
        <tfoot>
          <tr>
            <td colspan="5"></td>
            <td class="text-end"><strong>{{ $total_triaged | lang.FormatNumber 0 }}</strong></td>
          </tr>

          <tr></tr>
        </tfoot>
      </table>
    </div>

    {{ if gt $total_triaged 0 }}
      <h2>Triage Burndown</h2>

      <p>
        Total = {{ $total | lang.FormatNumber 0 }} / {{ $total_triaged | lang.FormatNumber 0 }} / 30
        = {{ div $total (div $total_triaged 30) | lang.FormatNumber 0 }} days
      </p>

      <div class="row">
        {{ range $i,$s := (slice "critical" "high" "unknown" "medium" "low" "info") }}
          <div class="col-xl-2 col-md-6 mb-4">
            <div class="card border-left-primary shadow h-100 py-2">
              <div class="card-body">
                <div class="row no-gutters align-items-center">
                  <div class="col mr-2">
                    <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                      {{ partial "severity" $s }}
                    </div>
                    <div class="h5 mb-0 font-weight-bold text-gray-800">
                      {{ div ((index $aging_vulns $s) | default 0) (div $total_triaged 30) | lang.FormatNumber 0 }}
                      days
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        {{ end }}
      </div>
    {{ end }}


    <h2>Aging vulnerabilities</h2>

    <div class="table-responsive">
      <table class="table table-striped table-hover">
        <thead>
          <tr class="text-end">
            <th scope="col" class="text-start">Severity</th>
            <th scope="col">Over 30 days</th>
            <th scope="col">Over 60 days</th>
            <th scope="col">Over 90 days</th>
            <th scope="col">Over 120 days</th>
            <th scope="col">Over 1 year</th>
          </tr>
        </thead>
        <tbody id="listTable">
          {{ range $vulnerabilities.aging }}
            <tr class="text-end">
              <td scope="row" class="text-start">{{ partial "severity" .severity }}</td>
              <td scope="row">{{ .over_30_days | lang.FormatNumber 0 }}</td>
              <td scope="row">{{ .over_60_days | lang.FormatNumber 0 }}</td>
              <td scope="row">{{ .over_90_days | lang.FormatNumber 0 }}</td>
              <td scope="row">{{ .over_120_days | lang.FormatNumber 0 }}</td>
              <td scope="row">{{ .over_1_year | lang.FormatNumber 0 }}</td>
            </tr>
          {{ end }}
        </tbody>
      </table>
    </div>

    <h2>Top 10 oldest vulnerabilities average</h2>

    <div class="table-responsive">
      <table class="table table-striped table-hover">
        <thead>
          <tr class="text-end">
            <th scope="col" class="text-start">#</th>
            <th scope="col" class="text-start">Project</th>
            <th scope="col">Average age (days)(Critical/High/Unknown)</th>
            <th scope="col">N (Critical/High/Unknown)</th>
            <th scope="col">Average age (days)</th>
            <th scope="col">N</th>
          </tr>
        </thead>
        <tbody id="listTable">
          {{ $counter := 0 }}
          {{ range $vulnerabilities.oldest_average }}
            {{ $counter = add $counter 1 }}
            <tr class="text-end">
              <th scope="row" class="text-start">{{ $counter }}</th>
              <td class="text-start">
                <a href="{{ printf "projects/%s" .path_with_namespace | urlize | relURL }}"
                  >{{ .path_with_namespace }}</a
                >
              </td>
              <td>{{ .avg_age_of_vulnerabilities_crit | lang.FormatNumber 0 }}</td>
              <td>{{ .number_of_vulnerabilities_crit | lang.FormatNumber 0 }}</td>
              <td>{{ .avg_age_of_vulnerabilities | lang.FormatNumber 0 }}</td>
              <td>{{ .number_of_vulnerabilities | lang.FormatNumber 0 }}</td>
            </tr>
          {{ end }}
        </tbody>
      </table>
    </div>

    <h2>Top 10 worse False Positive Rates</h2>

    {{ partial "vulnerabilities/false_true_positives.html" $vulnerabilities.worse_false_positive_rates }}


    <h2>Top 10 best True Positive Rates</h2>

    {{ partial "vulnerabilities/false_true_positives.html" $vulnerabilities.best_true_positive_rates }}
  {{ end }}
{{ end }}
